[![Go Reference](https://pkg.go.dev/badge/gitea.stuzer.link/stuzer05/go-monobank.svg)](https://pkg.go.dev/gitea.stuzer.link/stuzer05/go-monobank)
# Go API client for swagger

API для отримання інформації про виписки та стан особистого рахунку та рахунків ФОП. Для надання доступу потрібно пройти авторизацію у особистому кабінеті https://api.monobank.ua/ та отримати токен для персонального використання.  Якщо у вас є запитання щодо роботи API, запрошуємо до ком'юніті у [Telegram-групі](https://t.me/joinchat/FiAEWhDf-QzTqM4wzEtffw). API недоступне для клієнтів до 16 років, дані за дитячими рахунками доступні з батьківського акаунту. Якщо у вас є сервіс і ви хочете централізовано приєднатися до API для надання послуг клієнтам, потрібно підключитися до [API для провайдерів послуг](/docs/corporate.html), що має більше можливостей. Якщо дані клієнтів не будуть надходити на ваші сервери або ви робите сервіс для своєї родини, використання корпоративного API необов'язкове. Розробка бібліотек або програм, які будуть використовувати клієнти особисто (дані клієнта не будуть проходити черeз вузли розробника), також не потребують використання корпоративного API.  Це надасть змогу клієнтам monobank авторизуватись у вашому сервісі (наприклад, у фінансовому менеджері) для надання інформації про стан рахунку або виписки.  У разі виявлення експлуатації цього API в якості корпоративного, банк залишає за собою право накласти санкції на компанію.

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: v2303
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.go.GoClientCodegen

## Installation
Put the package under your project folder and add the following in import:
```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.monobank.ua*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*_Api* | [**BankCurrencyGet**](docs/_Api.md#bankcurrencyget) | **Get** /bank/currency | Отримання курсів валют
*_Api* | [**PersonalClientInfoGet**](docs/_Api.md#personalclientinfoget) | **Get** /personal/client-info | Інформація про клієнта
*_Api* | [**PersonalStatementAccountFromToGet**](docs/_Api.md#personalstatementaccountfromtoget) | **Get** /personal/statement/{account}/{from}/{to} | Виписка
*_Api* | [**PersonalWebhookPost**](docs/_Api.md#personalwebhookpost) | **Post** /personal/webhook | Встановлення WebHook

## Documentation For Models

 - [CurrencyInfoInner](docs/CurrencyInfoInner.md)
 - [ModelError](docs/ModelError.md)
 - [SetWebHook](docs/SetWebHook.md)
 - [StatementItemsInner](docs/StatementItemsInner.md)
 - [UserInfo](docs/UserInfo.md)
 - [UserInfoAccounts](docs/UserInfoAccounts.md)
 - [UserInfoJars](docs/UserInfoJars.md)

## Documentation For Authorization
 Endpoints do not require authorization.


## Author


