# {{classname}}

All URIs are relative to *https://api.monobank.ua*

Method | HTTP request | Description
------------- | ------------- | -------------
[**BankCurrencyGet**](_Api.md#BankCurrencyGet) | **Get** /bank/currency | Отримання курсів валют
[**PersonalClientInfoGet**](_Api.md#PersonalClientInfoGet) | **Get** /personal/client-info | Інформація про клієнта
[**PersonalStatementAccountFromToGet**](_Api.md#PersonalStatementAccountFromToGet) | **Get** /personal/statement/{account}/{from}/{to} | Виписка
[**PersonalWebhookPost**](_Api.md#PersonalWebhookPost) | **Post** /personal/webhook | Встановлення WebHook

# **BankCurrencyGet**
> []CurrencyInfoInner BankCurrencyGet(ctx, )
Отримання курсів валют

Отримати базовий перелік курсів валют monobank. Інформація кешується та оновлюється не частіше 1 разу на 5 хвилин.

### Required Parameters
This endpoint does not need any parameter.

### Return type

[**[]CurrencyInfoInner**](array.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **PersonalClientInfoGet**
> UserInfo PersonalClientInfoGet(ctx, xToken)
Інформація про клієнта

Отримання інформації про клієнта та переліку його рахунків і банок. Обмеження на використання функції не частіше ніж 1 раз у 60 секунд.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **xToken** | **string**| Token для особистого доступу до API | 

### Return type

[**UserInfo**](UserInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **PersonalStatementAccountFromToGet**
> []StatementItemsInner PersonalStatementAccountFromToGet(ctx, xToken, account, from, to)
Виписка

Отримання виписки за час від {from} до {to} часу в секундах в форматі Unix time. Максимальний час, за який можливо отримати виписку — 31 доба + 1 година (2682000 секунд).  Обмеження на використання функції — не частіше ніж 1 раз на 60 секунд.  Повертає 500 транзакцій з кінця, тобто від часу to до from. Якщо кількість транзакцій = 500, потрібно зробити ще один запит, зменшивши час to до часу останнього платежу, з відповіді. Якщо знову кількість транзакцій = 500, то виконуєте запити до того часу, поки кількість транзакцій не буде < 500. Відповідно, якщо кількість транзакцій < 500, то вже отримано всі платежі за вказаний період.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **xToken** | **string**| Token для особистого доступу до API | 
  **account** | **string**| Ідентифікатор рахунку або банки з переліків Statement list або 0 - дефолтний рахунок. | 
  **from** | **string**| Початок часу виписки. | 
  **to** | **string**| Останній час виписки (якщо відсутній, буде використовуватись поточний час). | 

### Return type

[**[]StatementItemsInner**](array.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **PersonalWebhookPost**
> PersonalWebhookPost(ctx, body, xToken)
Встановлення WebHook

Встановлення URL користувача: - Для підтвердження коректності наданої адреси, на неї надсилається GET-запит. Сервер має відповісти строго HTTP статус-кодом 200, і ніяким іншим. Якщо валідацію пройдено, на задану адресу починають надсилатися POST запити з подіями. - Події надсилаються у наступному вигляді: POST запит на задану адресу у форматі `{type:\"StatementItem\", data:{account:\"...\", statementItem:{#StatementItem}}}`. Якщо сервіс користувача не відповість протягом 5с на команду, сервіс повторить спробу ще через 60 та 600 секунд. Якщо на третю спробу відповідь отримана не буде, функція буде вимкнута. Відповідь сервера має строго містити HTTP статус-код 200.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **body** | [**SetWebHook**](SetWebHook.md)|  | 
  **xToken** | **string**| Token для особистого доступу до API | 

### Return type

 (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

