/*
 * Monobank open API
 *
 * API для отримання інформації про виписки та стан особистого рахунку та рахунків ФОП. Для надання доступу потрібно пройти авторизацію у особистому кабінеті https://api.monobank.ua/ та отримати токен для персонального використання.  Якщо у вас є запитання щодо роботи API, запрошуємо до ком'юніті у [Telegram-групі](https://t.me/joinchat/FiAEWhDf-QzTqM4wzEtffw). API недоступне для клієнтів до 16 років, дані за дитячими рахунками доступні з батьківського акаунту. Якщо у вас є сервіс і ви хочете централізовано приєднатися до API для надання послуг клієнтам, потрібно підключитися до [API для провайдерів послуг](/docs/corporate.html), що має більше можливостей. Якщо дані клієнтів не будуть надходити на ваші сервери або ви робите сервіс для своєї родини, використання корпоративного API необов'язкове. Розробка бібліотек або програм, які будуть використовувати клієнти особисто (дані клієнта не будуть проходити черeз вузли розробника), також не потребують використання корпоративного API.  Це надасть змогу клієнтам monobank авторизуватись у вашому сервісі (наприклад, у фінансовому менеджері) для надання інформації про стан рахунку або виписки.  У разі виявлення експлуатації цього API в якості корпоративного, банк залишає за собою право накласти санкції на компанію.
 *
 * API version: v2303
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package monobank

type CurrencyInfoInner struct {
	// Код валюти рахунку відповідно ISO 4217
	CurrencyCodeA float64 `json:"currencyCodeA,omitempty"`
	// Код валюти рахунку відповідно ISO 4217
	CurrencyCodeB float64 `json:"currencyCodeB,omitempty"`
	// Час курсу в секундах в форматі Unix time
	Date      float64 `json:"date,omitempty"`
	RateSell  float32 `json:"rateSell,omitempty"`
	RateBuy   float32 `json:"rateBuy,omitempty"`
	RateCross float32 `json:"rateCross,omitempty"`
}
