/*
 * Monobank open API
 *
 * API для отримання інформації про виписки та стан особистого рахунку та рахунків ФОП. Для надання доступу потрібно пройти авторизацію у особистому кабінеті https://api.monobank.ua/ та отримати токен для персонального використання.  Якщо у вас є запитання щодо роботи API, запрошуємо до ком'юніті у [Telegram-групі](https://t.me/joinchat/FiAEWhDf-QzTqM4wzEtffw). API недоступне для клієнтів до 16 років, дані за дитячими рахунками доступні з батьківського акаунту. Якщо у вас є сервіс і ви хочете централізовано приєднатися до API для надання послуг клієнтам, потрібно підключитися до [API для провайдерів послуг](/docs/corporate.html), що має більше можливостей. Якщо дані клієнтів не будуть надходити на ваші сервери або ви робите сервіс для своєї родини, використання корпоративного API необов'язкове. Розробка бібліотек або програм, які будуть використовувати клієнти особисто (дані клієнта не будуть проходити черeз вузли розробника), також не потребують використання корпоративного API.  Це надасть змогу клієнтам monobank авторизуватись у вашому сервісі (наприклад, у фінансовому менеджері) для надання інформації про стан рахунку або виписки.  У разі виявлення експлуатації цього API в якості корпоративного, банк залишає за собою право накласти санкції на компанію.
 *
 * API version: v2303
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package monobank

type StatementItemsInner struct {
	// Унікальний id транзакції
	Id string `json:"id,omitempty"`
	// Час транзакції в секундах в форматі Unix time
	Time float64 `json:"time,omitempty"`
	// Опис транзакцій
	Description string `json:"description,omitempty"`
	// Код типу транзакції (Merchant Category Code), відповідно ISO 18245
	Mcc float64 `json:"mcc,omitempty"`
	// Оригінальний код типу транзакції (Merchant Category Code), відповідно ISO 18245
	OriginalMcc float64 `json:"originalMcc,omitempty"`
	// Статус блокування суми (детальніше у [wiki](https://en.wikipedia.org/wiki/Authorization_hold))
	Hold bool `json:"hold,omitempty"`
	// Сума у валюті рахунку в мінімальних одиницях валюти (копійках, центах)
	Amount float64 `json:"amount,omitempty"`
	// Сума у валюті транзакції в мінімальних одиницях валюти (копійках, центах)
	OperationAmount float64 `json:"operationAmount,omitempty"`
	// Код валюти рахунку відповідно ISO 4217
	CurrencyCode float64 `json:"currencyCode,omitempty"`
	// Розмір комісії в мінімальних одиницях валюти (копійках, центах)
	CommissionRate float64 `json:"commissionRate,omitempty"`
	// Розмір кешбеку в мінімальних одиницях валюти (копійках, центах)
	CashbackAmount float64 `json:"cashbackAmount,omitempty"`
	// Баланс рахунку в мінімальних одиницях валюти (копійках, центах)
	Balance float64 `json:"balance,omitempty"`
	// Коментар до переказу, уведений користувачем. Якщо не вказаний, поле буде відсутнім
	Comment string `json:"comment,omitempty"`
	// Номер квитанції для check.gov.ua. Поле може бути відсутнім
	ReceiptId string `json:"receiptId,omitempty"`
	// Номер квитанції ФОПа, приходить у випадку якщо це операція із зарахуванням коштів
	InvoiceId string `json:"invoiceId,omitempty"`
	// ЄДРПОУ контрагента, присутній лише для елементів виписки рахунків ФОП
	CounterEdrpou string `json:"counterEdrpou,omitempty"`
	// IBAN контрагента, присутній лише для елементів виписки рахунків ФОП
	CounterIban string `json:"counterIban,omitempty"`
	// Найменування контрагента
	CounterName string `json:"counterName,omitempty"`
}
