/*
 * Monobank open API
 *
 * API для отримання інформації про виписки та стан особистого рахунку та рахунків ФОП. Для надання доступу потрібно пройти авторизацію у особистому кабінеті https://api.monobank.ua/ та отримати токен для персонального використання.  Якщо у вас є запитання щодо роботи API, запрошуємо до ком'юніті у [Telegram-групі](https://t.me/joinchat/FiAEWhDf-QzTqM4wzEtffw). API недоступне для клієнтів до 16 років, дані за дитячими рахунками доступні з батьківського акаунту. Якщо у вас є сервіс і ви хочете централізовано приєднатися до API для надання послуг клієнтам, потрібно підключитися до [API для провайдерів послуг](/docs/corporate.html), що має більше можливостей. Якщо дані клієнтів не будуть надходити на ваші сервери або ви робите сервіс для своєї родини, використання корпоративного API необов'язкове. Розробка бібліотек або програм, які будуть використовувати клієнти особисто (дані клієнта не будуть проходити черeз вузли розробника), також не потребують використання корпоративного API.  Це надасть змогу клієнтам monobank авторизуватись у вашому сервісі (наприклад, у фінансовому менеджері) для надання інформації про стан рахунку або виписки.  У разі виявлення експлуатації цього API в якості корпоративного, банк залишає за собою право накласти санкції на компанію.
 *
 * API version: v2303
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package monobank

type UserInfoJars struct {
	// Ідентифікатор банки
	Id string `json:"id,omitempty"`
	// Ідентифікатор для сервісу https://send.monobank.ua/{sendId}
	SendId string `json:"sendId,omitempty"`
	// Назва банки
	Title string `json:"title,omitempty"`
	// Опис банки
	Description string `json:"description,omitempty"`
	// Код валюти банки відповідно ISO 4217
	CurrencyCode float64 `json:"currencyCode,omitempty"`
	// Баланс банки в мінімальних одиницях валюти (копійках, центах)
	Balance float64 `json:"balance,omitempty"`
	// Цільова сума для накопичення в банці в мінімальних одиницях валюти (копійках, центах)
	Goal float64 `json:"goal,omitempty"`
}
